CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  sd_FirstPin = 0  'use pins P0 to P3

Var
  long file_buf[1024] ' long alligned 4096 bytes

OBJ
  D : "FullDuplexSerial"
  SD: "fsrw_23"
                                                                  
PUB Main
   D.Start(31,30,0,115200)
   D.rx    'wait for the user to press any key on the Parallax Serial Terminalto start the demo
   D.Str(string(16,"Doing Write Test",13))
   D.Str(string("Mounting",13))
   if sd.mount(sd_FirstPin) => 0  'mount the SD card
      D.Str(string("Writing",13))
      CreateFile
      D.Str(string("Done Writing",13))
      sd.unmount
      D.Str(string("Unmounted",13))
   D.Str(string("Done Writing Test",13))
   D.Str(string(13,"Doing Read Test",13))
   D.Str(string("Mounting",13))
   if sd.mount(sd_FirstPin) => 0  'mount the SD card
      D.Str(string("Reading",13))
      ReadFile
      D.Str(string("Done Reading",13))
      sd.unmount
      D.Str(string("Unmounted",13))
   D.Str(string("Done Read Test",13))
Pri CreateFile
      D.Str(string("Openning",13))
      if sd.popen( @FileName, "w" ) => 0  'open file for write
        sd.pputs(@StringVar)  'writing a string (has to be 0 terminated)
        sd.pputs(string("Writing some variables as text:",13,10))
        MakeText(LongVar)
        sd.pputs(@Text_Num)  
        sd.pputs(string(","))  
        MakeText(WordVar)
        sd.pputs(@Text_Num)  
        sd.pputs(string(","))  
        MakeText(ByteVar)
        sd.pputs(@Text_Num)  
        sd.pputs(string(13,10))  
        sd.pputs(string("Writing some variables as binaries",13,10))  
        sd.pputs(string("You will just see 12 bytes of garbage now:",13,10))  
        sd.pwrite(@LongVar,4) 'write a Long as a binary
        sd.pwrite(@WordVar,2) 'write a word as a binary
        sd.pwrite(@ByteVar,1) 'write a byte as a binary
        sd.pwrite(@Block,1*5) 'write a block of bytes (could be other type) as binary
                              'make sure you have the right length by changing 1 to 2 or 4
                              'for word or long
        D.Str(string("Closing",13))
        sd.pclose
Pri ReadFile|n,i
      D.Str(string("Openning",13))
      if sd.popen( @FileName, "r" ) => 0  'open file for write
        D.Str(string("The following is data from the file",13))
        D.Str(string("-----------------------------------",13))
        n := sd.pread(@File_Buf,1024*4)  'reads all the file n= length read
        D.Str(@File_Buf)
        D.Str(string(13,"----------------------------------",13))
        D.Str(string("Closing",13))
        sd.pclose
        D.Str(string(13,"Reformatting the Binary numbers",13))
      'we want to point to 12 bytes from the end of the string read
      n := (@File_Buf+n)-12
      D.Dec(Long[n])
      D.Tx(",")
      D.Dec(Word[n+4])
      D.Tx(",")
      D.Dec(Byte[n+6])
      repeat i from 0 to 4
        D.Tx(",")
        D.Dec(Byte[n+7+i])
      D.Str(string(13,"Done Reformatting the binary numbers",13,13))

PUB MakeText(value)|j, i
'' create a string number out of value
  repeat i from 0 to 14  'zero it
    Text_Num[i]~
  j~  
  if value < 0
    -value
    Text_Num[j++] := "-"
  i := 1_000_000_000
  repeat 10
    if value => i
      Text_Num[j++] := (value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      Text_Num[j++] := "0"
    i /= 10

Dat
   Text_Num  byte 0[15]  '15 bytes for holding a text number
   FileName  byte "test.tst",0
   StringVar byte "This is a test string variable",13,10,0
   LongVar   long 7604567
   WordVar   word 12345
   ByteVar   byte 234
   Block     byte 0,13,45,345,9 
       